/***************************************************************************
                          tea_about.c  -  description
                             -------------------
    begin                : august 2004
    copyright            : (C) 2004 by Peter 'Roxton' Semiletov
    email                : tea@list.ru
 **************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 **************************************-************************************/


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "tea_defs.h"


gchar *a_logo[] = {
                    "0000000000000000000",
                    "0111110111100001000",
                    "0001000100000010100",
                    "0001000111100010100",
                    "0001000100000101010",
                    "0001000111100100010",
                    "0000000000000000000"
                   };


static gint it = 0;
static gboolean is_wnd_run = FALSE;


static GRand *rand_color;   

#define side_size_x 20
#define side_size_y 35



static gboolean cb_wnd_destroy_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  is_wnd_run = FALSE;
  return FALSE;
}


static void cb_on_bt_close (GtkObject *object, GtkWidget *w) 
{
  is_wnd_run = FALSE;
  window_destroy (w);
}


static GdkPixmap *pixmap = NULL;


static gboolean cb_draw_iteration (gpointer data)
{
  if (! is_wnd_run)
     return FALSE;

  if (! data)
     return FALSE;


  GtkWidget *widget = data;
  
  if (! widget->window)
     return FALSE; 

   if (pixmap)
      gdk_pixmap_unref(pixmap);

  pixmap = gdk_pixmap_new (widget->window,
                           widget->allocation.width,
                           widget->allocation.height,
                           -1);

  GtkStyle *stl = widget->style->fg_gc[GTK_STATE_NORMAL];
    
  gint x;
  gint y;

  GdkColor color;
 
  gint32 r;

  rand_color = g_rand_new ();
  
  it++;

  if (it == 5)
     it = 0; 

  for (y = 0; y <= 6; y++)
  for (x = 0; x <= 19; x++)
      {
       if (a_logo [y][x] == '1')
          {
           switch (it)
                 {
                  case 0: gdk_color_parse ("#ab621b", &color);
                          break;

                  case 1: gdk_color_parse ("#cd1515", &color);
                          break;

                  case 2: gdk_color_parse ("#b730a7", &color);
                          break;

                  case 3: gdk_color_parse ("#df1113", &color);
                          break;

                  case 4: gdk_color_parse ("white", &color);
                          break;
                 }
          } 
    else
        {
         switch (g_rand_int_range (rand_color, 0, 4))
                {
                  case 0: gdk_color_parse ("#322b47", &color); 
                          break;

                  case 1: gdk_color_parse ("#77608d", &color); 
                          break;
 
                  case 2: gdk_color_parse ("#6c97ab", &color); 
                          break;

                  case 3: gdk_color_parse ("#322b47", &color); 
                          break;
 

                  case 4: gdk_color_parse ("#322b47", &color); 
                          break;
              }
        }

       gdk_gc_set_rgb_fg_color (stl, &color);
    
       gdk_draw_rectangle (pixmap,
                           stl,
                           TRUE,
                           x * side_size_x, 
                           y * side_size_y, 
                           side_size_x,
                           side_size_y);

       }
                          
  gdk_draw_drawable  (widget->window, stl, pixmap, 0, 0, 0, 0, -1, -1);

  g_rand_free (rand_color);
    
  //n.p. The Orb - Asylum [kris & dave's you are evil [but i like you]

  return TRUE;
}




GtkWidget* create_wnd_about (void)
{
  GtkWidget *wnd_about;
  GtkWidget *vbox1;
  GtkWidget *notebook1;
  GtkWidget *drawingarea_canvas;
  GtkWidget *l_logo;
  GtkWidget *scrolledwindow1;
  GtkWidget *tv_code;
  GtkWidget *l_code;
  GtkWidget *scrolledwindow4;
  GtkWidget *tv_thanx;
  GtkWidget *l_thanx;
  GtkWidget *scrolledwindow2;
  GtkWidget *tv_translators;
  GtkWidget *l_translators;
  GtkWidget *scrolledwindow3;
  GtkWidget *tv_rpms;
  GtkWidget *l_rpm;
  GtkWidget *bt_close;

  gchar *f = get_tea_doc_compose_name ("AUTHORS");
  //dbm (f);
  gchar *s = str_file_read (f);  
  
  gchar **ad;
  if (s)
     ad = g_strsplit (s, "##", -1);

  g_free (f);
  g_free (s);

  wnd_about = gtk_window_new (GTK_WINDOW_TOPLEVEL);


  gtk_window_set_title (GTK_WINDOW (wnd_about), _("About"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (wnd_about), vbox1);

  notebook1 = gtk_notebook_new ();
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (vbox1), notebook1, TRUE, TRUE, 0);

  drawingarea_canvas = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea_canvas);
  gtk_container_add (GTK_CONTAINER (notebook1), drawingarea_canvas);

  l_logo = gtk_label_new (_("Logo"));
  gtk_widget_show (l_logo);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), l_logo);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (notebook1), scrolledwindow1);

  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  tv_code = gtk_text_view_new ();
  gtk_widget_show (tv_code);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), tv_code);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (tv_code), FALSE);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (tv_code), GTK_WRAP_WORD);
 

  l_code = gtk_label_new (_("Code"));
  gtk_widget_show (l_code);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), l_code);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow4);
  gtk_container_add (GTK_CONTAINER (notebook1), scrolledwindow4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  tv_thanx = gtk_text_view_new ();
  gtk_widget_show (tv_thanx);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), tv_thanx);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (tv_thanx), FALSE);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (tv_thanx), GTK_WRAP_WORD);

  l_thanx = gtk_label_new (_("Thanks"));
  gtk_widget_show (l_thanx);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), l_thanx);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (notebook1), scrolledwindow2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  tv_translators = gtk_text_view_new ();
  gtk_widget_show (tv_translators);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), tv_translators);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (tv_translators), FALSE);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (tv_translators), GTK_WRAP_WORD);

  l_translators = gtk_label_new (_("Translators"));
  gtk_widget_show (l_translators);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 3), l_translators);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (notebook1), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  tv_rpms = gtk_text_view_new ();
  gtk_widget_show (tv_rpms);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), tv_rpms);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (tv_rpms), FALSE);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (tv_rpms), GTK_WRAP_WORD);


  l_rpm = gtk_label_new (_("Packages"));
  gtk_widget_show (l_rpm);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 4), l_rpm);

  bt_close = gtk_button_new_with_mnemonic (_("Close"));
  gtk_widget_show (bt_close);
  gtk_box_pack_start (GTK_BOX (vbox1), bt_close, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (bt_close, GTK_CAN_DEFAULT);

  g_signal_connect (bt_close, "clicked", G_CALLBACK (cb_on_bt_close), wnd_about);

  gtk_widget_grab_focus (bt_close);
  gtk_widget_grab_default (bt_close);

  gtk_window_set_modal (wnd_about, TRUE);

  is_wnd_run = TRUE;

  if (get_gchar_array_size (ad) == 4)
     {
      gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (tv_code)), g_strchug (ad[0]), -1);
      gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (tv_rpms)), g_strchug (ad[2]), -1);
      gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (tv_translators)), g_strchug (ad[1]), -1);
      gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (tv_thanx)), g_strchug (ad[3]), -1);
     }

  guint id = g_timeout_add  (500, cb_draw_iteration, drawingarea_canvas);
  
  gtk_window_set_position (GTK_WINDOW (wnd_about), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (wnd_about), 400, 350);
  
  g_signal_connect ((gpointer) wnd_about, "destroy",
                    G_CALLBACK (cb_wnd_destroy_event),
                    NULL);
    
  g_strfreev (ad);

  gtk_widget_show (wnd_about);
  return wnd_about;
}


